%global pkg_name dlrn
%global py_name DLRN

Name:           %{pkg_name}
Version:        0.0.1.dev331
Release:        1%{?dist}
Summary:        DLRN builds and maintains yum repositories following OpenStack uptream commit streams

License:        ASL 2.0
URL:            https://github.com/openstack-packages/DLRN
Source0:        https://github.com/openstack-packages/DLRN/archive/%{py_name}-%{version}.tar.gz
Source1:        run-dlrn.sh
Source2:        projects.ini
Source3:        dlrn.service
Source4:        dlrn.timer

BuildArch:      noarch
 
BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  httpd
BuildRequires:  systemd
# Required to build documentation
BuildRequires:  python-sphinx >= 1.1.2
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-sphinx_rtd_theme

Requires:       httpd
Requires:       mock
Requires:       rpm-build
Requires:       createrepo
Requires:       git
Requires:       python-babel
Requires:       python-jinja2
Requires:       python-oslo-config
Requires:       python-sh
Requires:       python-six
Requires:       python-sqlalchemy
Requires:       PyYAML
Requires:       rdopkg >= 0.25
Requires:       python-prettytable

Requires(pre): shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd


%description
DLRN builds and maintains yum repositories following OpenStack uptream commit streams.

%prep
%setup -q -n %{py_name}-%{version}

# generate html docs 
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%build
%py2_build

%install
%py2_install

# Setup directories
install -d -m 755 %{buildroot}%{_sysconfdir}/%{pkg_name}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{pkg_name}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{pkg_name}/data

# Create default symlink to centos7 data directory
install -d -m 755 %{buildroot}%{_localstatedir}/www/html
ln -s %{_sharedstatedir}/%{pkg_name}/data/repos %{buildroot}%{_localstatedir}/www/html/centos7

# Install execution script
install -p -D -m 755 %{SOURCE1} %{buildroot}%{_bindir}/run-dlrn

# Install default configuration
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{pkg_name}/projects.ini

# Install systemd files
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/dlrn.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/dlrn.timer

%pre
getent group %{pkg_name} >/dev/null || groupadd -r %{pkg_name}
getent passwd %{pkg_name} >/dev/null || \
    useradd -m -r -g %{pkg_name} -G mock -s /bin/bash -c "DLRN user" %{pkg_name}
exit 0

%post
%systemd_post dlrn.service
%systemd_post dlrn.timer
semanage fcontext -a -t httpd_sys_content_t /var/lib/dlrn/data

%preun
%systemd_preun dlrn.service
%systemd_preun dlrn.timer

%postun
%systemd_postun dlrn.service
%systemd_postun dlrn.timer

%files
%doc README.rst HACKING.rst CONTRIBUTING.rst html
%license LICENSE
%dir %attr(0755, %{pkg_name}, %{pkg_name}) %{_sysconfdir}/%{pkg_name}
%dir %attr(0755, %{pkg_name}, %{pkg_name}) %{_sharedstatedir}/%{pkg_name}/data
%config(noreplace) %attr(0640, %{pkg_name}, %{pkg_name}) %{_sysconfdir}/%{pkg_name}/projects.ini
%{_unitdir}/dlrn.service
%{_unitdir}/dlrn.timer
%{_bindir}/delorean
%{_bindir}/delorean-compare
%{_bindir}/dlrn
%{_bindir}/dlrn-purge
%{_bindir}/run-dlrn
%{_localstatedir}/www/html/centos7
%{_datarootdir}/%{pkg_name}/scripts
%{python2_sitelib}/dlrn
%{python2_sitelib}/DLRN-%{version}-py?.?.egg-info

%changelog
* Thu Apr 28 2016 Javier Peña <jpena@redhat.com> - 0.0.1.dev331-1
- Renamed to DLRN
- Updated scripts

* Thu Feb 11 2016 jpena <jpena@redhat.com> - 0.0.1.dev269-1
- Use systemd timers instead of a cron file 

* Thu Feb 4 2016 jpena <jpena@redhat.com> - 0.0.1.dev256-1
- Moving scripts to /usr/share/delorean/scripts

* Thu Feb 4 2016 jpena <jpena@redhat.com> - 0.0.1.dev255-2
- Making Delorean a top-level package

* Wed Feb 3 2016 jpena <jpena@redhat.com> - 0.0.1.dev255-1
- Initial package.
